; Mick West 1990, Ocean.
;
; program that simulates a ram disk, lets me have all my files on the PC
; when this is assembled it will put all the files in memory above 1 meg
; then you can load from there
;
; Also with mastering program!!! & encryption, checksums etc!!!
;
; (For use with SNASM)
;
; the files are stored in a linked list with a 3 LW header+filename
;
;	dc.l	address of start of file (or -1.L if last file)
;	dc.l	length of file
;  	dc.l	address of next header 
;	dc.b	filename.....
;
;  


; for testing the checksum bits

;master	equ	1		     
;run	equ	1


;	workspace   	$70000

	ifnd	master
master	equ	0
	endc

	ifnd	run
run	equ	0
	endc

	ifnd	st
st	equ	-0
	endc

	ifnd	demo
demo	equ	-1			; set to 1 for unprotetected files
	endc

encrypt_program	equ	-0

	ifnd	ram_pass
ram_pass	equ	1
	endc

amiga	equ	~st

	if	master=1
	org	$1000
	regs	pc=start,sr=$2700
mastering

start	
	nolist
	include	\ram\master.s
	list
	endc

; the normal ram disk starts here

	ifne	st
	org	$100000
	elseif
	org	$c00000
	endc

_ram_start


files		set	0

_ram_file	macro	filename
		dc.l	.start\@
		dc.l	.end\@-.start\@
		dc.l	.next\@	
		dc.b	"\filename",0
		even
.start\@
		incbin	\_ram_path\\1
.end\@
files	set	files+1	
		even
.next\@
		endm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; the following stuff is specific to your program, 
; the path that all the files are found in, and the file names
; the path can be redefined at any time, but it is sometimes neater
; to keep all your files in one place, for final mastering etc, but WTH.


; this is now incbinned at BBUFFER
;	if	master=1
;_ram_path	equs	"c:\dm\"
;	_ram_file	dm.prg
;	endc	


	if	ram_pass=1

_ram_path	equs	"c:\ps\files\"
	_ram_file	bigocean.spr		; title logo

;	dc.l	-1

	_ram_file	chr8x8.spr		; the font 
	_ram_file	title.spr		; title logo
	_ram_file	ocean.spr
_ram_path	equs	"c:\med\"
;	_ram_file	simp5.mod		; music	
_ram_path	equs	"c:\ps\files\"
	_ram_file	parasol1.mod		; main tune
	_ram_file	parasolx.mod		; main tune
	_ram_file	parasol2.mod	      	; hs tune
	_ram_file	parasol3.mod	   	; eog tune
	_ram_file	parasol4.mod	 	; extra level
	_ram_file	parasol5.mod	 	; finished everything
	_ram_file	parasol6.mod	 	; eolb

	_ram_file	demo141.dat
	_ram_file	demo251.dat
	_ram_file	demo331.dat

	_ram_file	icons.spr
	_ram_file	items.spr		; power up icons
	_ram_file	food.spr		; food icons
	_ram_file	numbers.spr 		; numbers and messages
	if	amiga
	_ram_file	bub.spr			; main man and brolly
	elseif
	_ram_file	bubst.spr			; main man and brolly
	endc
	_ram_file	drops.spr    		; drips and drops
	_ram_file	gaiko.spr		; nasty green thingy 
	_ram_file	sfx.mod			; sound effects

	if	amiga
_ram_path	equs	"c:\ps\"
	endc	
	_ram_file	bubbob.spr
	_ram_file	planets.spr
_ram_path	equs	"c:\ps\files\"

; stuff after here is independant for each level
; 111111111111111111111111111111111111111111111111111111
	_ram_file	world1.mik  		; maps for l1
	if	amiga
	_ram_file	bg1.mik	
	elseif
	_ram_file	st_bg1.spr
	endc
	_ram_file	kas.spr	    		; baddies for l1
	_ram_file	akdon.spr
	_ram_file	pet.spr
	_ram_file	pian.spr
	_ram_file	torai.spr

	_ram_file	don.spr			; eolb for L1

; 222222222222222222222222222222222222222222222222222222222222222
	_ram_file	world2.mik  		; maps for l2
	if	amiga
	_ram_file	bg2.mik			
	elseif
	_ram_file	st_bg2.spr
	endc
	_ram_file	bat.spr			; baddies for l2
	_ram_file	applle.spr
	_ram_file	igaiga.spr
	_ram_file	uni.spr
	_ram_file	vio.spr
	if	st
_ram_path	equs	"c:\ps\stgen\"
	endc
	if	demo
_ram_path	equs	"c:\ps\ungen\"
	endc
	_ram_file	kiri.spr
_ram_path	equs	"c:\ps\files\"
	_ram_file	cya.spr

;	_ram_file	world2.mix


	_ram_file	hivio.spr		; eolb for l2
;
;;33333333333333333333333333333333333333333333333333333333333
;
	_ram_file	world3.mik  		; maps for l3
	if	amiga
	_ram_file	bg3.mik	 
	elseif
	_ram_file	st_bg3.spr
	endc


	_ram_file	penguin.spr		; baddies for l3
	_ram_file	taco.spr	
	_ram_file	eramo3.spr
	_ram_file	grincr.spr
	if	st
_ram_path	equs	"c:\ps\stgen\"
	endc
	if	demo
_ram_path	equs	"c:\ps\ungen\"
	endc
	_ram_file	yado.spr
_ram_path	equs	"c:\ps\files\"
	_ram_file	hikame.spr
	_ram_file	kame.spr

	_ram_file	hieramo.spr     

;4444444444444444444444444444444444444444444444444444444

	_ram_file	world4.mik
	if	amiga
	_ram_file	bg4.mik	   
	elseif
	_ram_file	st_bg4.spr
	endc


	if	st^demo
_ram_path	equs	"c:\ps\stgen\"
	endc
_ram_path	equs	"c:\ps\ungen\"
	_ram_file	ganhed.spr			
_ram_path	equs	"c:\ps\files\"
	_ram_file	chess.spr		
	_ram_file	katana.spr		
	_ram_file	tom.spr		
	_ram_file	ford.spr		
;	_ram_file	hikame.spr		
	_ram_file	keite2.spr	
	  
	_ram_file	hitom.spr	     

;55555555555555555555555555555555555555555555555555555555555
	_ram_file	world5.mik
	if	amiga
	_ram_file	bg5.mik	 
	elseif
	_ram_file	st_bg5.spr
	endc


	if	st
_ram_path	equs	"c:\ps\stgen\"
	endc
_ram_path	equs	"c:\ps\ungen\"

	_ram_file	slot.spr	
_ram_path	equs	"c:\ps\files\"
	_ram_file	coin.spr	
	_ram_file	king.spr	
	_ram_file	dice.spr	

	_ram_file	gbos1.spr	     
			

	_ram_file	bonus.mik

;66666666666666666666666666666666666666666666666666666666666666
	_ram_file	world6.mik
	if	amiga
	_ram_file	bg6.mik			
	elseif
	_ram_file	st_bg6.spr
	endc


	_ram_file	para.spr
	_ram_file	heri.spr
	_ram_file	heribo.spr
	_ram_file	himawa.spr
	_ram_file	ufo.spr
	_ram_file	panpan.spr

	_ram_file      hiufo.spr	     

;7777777777777777777777777777777777777777777777777777777777777777

	_ram_file	world7.mik
	if	amiga
	_ram_file	bg7.mik			
	elseif
	_ram_file	st_bg7.spr
	endc


	_ram_file    	dragon.spr
	_ram_file	keiten.spr
	_ram_file	saicro.spr

	_ram_file	gatt.spr	    
 
;88888888888888888888888888888888888888888888888888888888888888888

	_ram_file	world8.mik
	if	amiga
	_ram_file	bg8.mik	
	elseif
	_ram_file	st_bg8.spr
	endc


	_ram_file      	jack.spr
	_ram_file	spaceman.spr
	_ram_file	lizard.spr
	_ram_file	dracula.spr
	_ram_file	ghost.spr
	_ram_file	doh.spr

	_ram_file	rsboss.spr     
			
;999999999999999999999999999999999999999999999999999999999999999999

	_ram_file	world9.mik
	if	amiga
	_ram_file	bg9.mik			
	elseif
	_ram_file	st_bg9.spr
	endc


	_ram_file	zencan.spr
	_ram_file	zencan2.spr
	_ram_file	pulu.spr
	_ram_file	inbe.spr
	_ram_file	banebo.spr
	_ram_file	hidego.spr
	_ram_file	maita.spr

	_ram_file	hidorn.spr	     

;100000000000000000000000000000000000000000000000000000000000000000

	_ram_file	world0.mik
	if	amiga
	_ram_file	bg0.mik			
	elseif
	_ram_file	st_bg0.spr
	endc


	_ram_file	chacun.spr
	_ram_file	monsut.spr

  	_ram_file	maita2.spr
	_ram_file	bmaita.spr

	_ram_file	worldx.mik	     
	if	amiga
	_ram_file	bgx.mik	     
	elseif
	_ram_file	st_bgx.spr
	endc


	_ram_file	gore.spr
	_ram_file	hiplipjp.spr
	_ram_file	iolo.spr
	_ram_file	jippys.spr
	_ram_file	midge.spr
	_ram_file	omadon.spr
	_ram_file	ettin.spr

	_ram_file	all.spr

	if	amiga
	_ram_file	theend.spr
	elseif
	_ram_file	theendst.spr
	endc

	_ram_file	chackn.spr

	endc

	if	amiga&(ram_pass=2)
	_ram_file	mod.ld1
	_ram_file	mod.ov1
	_ram_file	mod.dm1
	endc


	inform	0,"PARASOL STARS AMIGA RAM DISK SETUP"
	inform	0,"%d files in %d bytes",files,*-_ram_start	     
	inform	0,"Sending files............."	  

	
; you should leave the following terminator
	dc.l	-1

_ram_len equ	(*)-(_ram_start)


