;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; kernalps.s New improved kernal program for Parasol_stars

	ifnd	st
st	equ	-0
	endc
amiga	equ	~st

	ifnd	display_start
	if	pal
display_start	equ	$40
	elseif
display_start	equ	$2c
	endc
	endc

	if	maxw=23
the_diwstrt	equ	display_start<<8+$91
	elseif
the_diwstrt	equ	display_start<<8+$81		; display start
	endc

;	if	maxw=23
;display_x	equ	$80
;	elseif
display_x	equ	$90
;	endc


; Hmmm, we need to be relocatable, so check if we are where we should be
	lea	start(pc),a0
	cmp.l	#base,a0
	beq	.hunky_dory
; oh shit, lost in memory, let us try to find our way out
	lea	.copier(pc),a0
	lea	$7ff00,a1
	move.w	#256/4-1,d0
.x	move.l	(a0)+,(a1)+
	dbf	d0,.x
	
	lea	start(pc),a0  			; from wherever it is
	move.l	#base,a1	 		; to base
	move.l	#100000,d0 			; length of program
	move.l	#base+.hunky_dory-start,a6	; 
	jmp	$7ff00

.copier
	cmp.l	a0,a1
	blt.s	.copy_up
	add.l	d0,a0
	add.l	d0,a1
.copy_down
	move.b	-(a0),-(a1)
	subq.l	#1,d0
	bne.s	.copy_down
	jmp	(A6)
.copy_up
	move.b	(a0)+,(a1)+
	subq.l	#1,d0
	bne	.copy_up
	jmp	(a6)	
.hunky_dory

*******************************************************************
;	move.w	#$fff,$dff180

	lea	stack,sp
	bsr	setup	

;	move.w	#-1,d0
;.bomb
;	move.w	d0,$dff180
;	dbf	d0,.bomb

*********************************************************************


	jmp	main


; what happens with these coppers

;	copper1 is set to JUMP_COPPER
;	at next VBL JUMP_COPPER sets copper to MAIN_COPPER_1
;	later JUMP_COPPER is modified so any attempt to run it will crash
;	at next VBL MAIN_COPPER_1 sets copper to MAIN_COPPER
;	at start of MAIN_COPPER copper1 is set to BAD_COPPER
;	BAD_COPPER is never executed, as MAIN_COPPER will reset 
;	the copper list to MAIN_COPPER at the end of the screen (before vbl) 	
;	this defeats Action Replay III's restart code.

jump_copper
	dc.w	cop1lch,0
copper_confuse
	dc.w	cop1lcl,main_copper_1
;	dc.w	colour0,$00f
copper_death_poke
	dc.w	copjmp1,0
	if	use_bad_copper
	dc.w	bltdpth,0
	dc.w	bltdptl,start
	dc.w	bltcon0,%0000100111110000	
	dc.w	bltsize,%1111111111111111     
	elseif	
	dc.w	copjmp1,0
	endc


	if	use_bad_copper
bad_copper
	dc.w	bltdpth,0
	dc.w	bltdptl,start
	dc.w	bltcon0,%0000100111110000	
	dc.w	bltsize,%1111111111111111	
	endc



noff	equ	5   			; number of bit planes
woff	equ	2		      	; offset between words in BP
loff	equ	(maxw)*2*noff	    	; offset between lines
poff	equ	(maxw)*2		; offset between bitplanes


;	include	\dev\pushpop.s
	include	\dev\hardware.s
	include	\dev\keyboard.s

setup
	lea	custom,a6
;	move.w	#%11,copcon(a6)		; CDANG on
;	move.w	#$732,$dff180
	bsr	kill_vectors
;	move.w	#$0f0,$dff180
	bsr	setup_screens	
;	move.w	#$00f,$dff180
	bsr	setup_copper
;	move.w	#$ff0,$dff180
	bsr	setup_vbl
;	move.w	#$0ff,$dff180
	bsr	setup_keyboard
;	move.w	#$f00,$dff180
	move.w	#$2100,sr
	pause	#10
;	move.w	#$777,$dff180
	move.w	#$11e,copper_death_poke
	clr.w	copper_confuse+2
	ret

kill_vectors
	move.l	$80,d0
	if	final
	lea	8,a0
	move.w	#($400-$8)/4-2,d7
	elseif
	lea	$28,a0
	move.w	#($400-$28)/4-2,d7
	endc
.next	move.l	#just_rte,(a0)+
	dbf	d7,.next

	ifeq	final
	cmp.w	#$400,d0
	bne	.no_vector8
	move.l	d0,$80
.no_vector8
	elseif
clueless
	move.l	#die_hacker_scum,$c		; this is garbage
	endc

	ret

	if	final
die_hacker_scum		    		; as is this (probs with a500+)
	pushem
;
;;	move.l	#main_copper,cop1lch  	; even the copper list
; ;
;; for parasol stars remove the routine that creates the baddies
;	ifd	parasol_stars
;	lea	create_this_baddy,a0
;	move.w	#(generator_pattern_table-create_this_baddy)/2-1,d0
;.x	move.w	#$4e75,(a0)+
;	dbf	d0,.x
;	endc
;
;; remove all trace of the old address error vector
;	move.l	#just_rte,$c
;	lea	clueless,a0
;.here
;	move.w	#(.here-clueless)/2-1,d0
;.y	move.w	#$4e75,(a0)+
;	dbf	d0,.y

	popem
	rte
	endc

setup_screens
	move.l	#screen1,screen
	move.l	#screen2,real
	rts


setup_copper

; what it was	
	if	use_bad_copper
	move.l	#jump_copper,cop1lch(a6)
	move.l	#$4e714e71,*-4
	elseif
	move.l	#main_copper,cop1lch(a6)
	endc

; tell AR3 that cop1lch is set to copjmp2
;	move.l	#copjmp2+custom,cop1lch(a6)
;; start up copper 1 via copper 2
;	move.l	#jump_copper2,cop2lch(a6)
;	move.w	d0,copjmp2(a6)
	

	ifnd	parasol_stars
	move.w	#%1000011111000000,dmaconw(a6) 	; screen etc on
	elseif
	move.w	#%1000011011000000,dmaconw(a6) 	; screen off for start of PS
	endc

;	move.w	d0,copjmp2(a6)

	rts


jump_copper2
	dc.w	cop1lch,0
	dc.w	cop1lcl,jump_copper
	dc.w	$ffff,$fffe		; end copper

setup_vbl
	move.w	 #%0111111111111111,intena(a6) 	; all ints off
	move.l	 #the_vbl,vblvec			
	move.w	 #%1100000000010000,intena(a6)	; enable copper ints
	rts


fudge		dc.l	0
fudge1		dc.l	0
reset_clock	dc.w	-1

; this use to have bit 14 set in all the INTENA, INTREQ pokes below
; that turned off the master interrupts and may have been the
; cause of some problems with the disk loader
the_vbl:
	move.w	#%0000000000010000,custom+intena
    	movem.l	d0-d7/a0-a6,-(a7)
	lea	custom,a6

	if	~run
      	jsr	read_joysticks
	endc

	add.l	#1,time

;	move.w	#time+2,$dff180

	add.w	#1,frame_time
	jsr	my_vbl

	movem.l (a7)+,d0-d7/a0-a6
	move.w	#%0000000000010000,custom+intreq
	move.w	#%1000000000010000,custom+intena
just_rte
	rte



;	dc.w	colour0,$fff	

	if	~use_bad_copper
bad_copper
	endc
; copper for hardware scroll

main_copper
	if	use_bad_copper
	dc.w	cop1lch,0	     		; kill copper for the duration
	dc.w	cop1lcl,bad_copper
	endc
main_copper_1

sprite_paths_1					; 0/1
	dc.w	spr0pth,dummy_sprite>>16
	dc.w	spr0ptl,dummy_sprite&$ffff
	dc.w	spr1pth,dummy_sprite>>16
	dc.w	spr1ptl,dummy_sprite&$ffff
sprite_paths_2					; 2/3
	dc.w	spr2pth,dummy_sprite>>16
	dc.w	spr2ptl,dummy_sprite&$ffff
	dc.w	spr3pth,dummy_sprite>>16
	dc.w	spr3ptl,dummy_sprite&$ffff
sprite_paths_3					; 4/5
	dc.w	spr4pth,dummy_sprite>>16
	dc.w	spr4ptl,dummy_sprite&$ffff
	dc.w	spr5pth,dummy_sprite>>16
	dc.w	spr5ptl,dummy_sprite&$ffff
	dc.w	spr6pth,silly>>16
	dc.w	spr6ptl,silly&$ffff
	dc.w	spr7pth,dummy_sprite>>16
	dc.w	spr7ptl,dummy_sprite&$ffff

	dc.w	$2001,$ff00	; dont do anything for few lines so we
				; can change the copper in the VBL time	

	dc.w	dmaconw,%1000011001100000 	; Blitter nasty on

; for first 16 lines there are just 4 bpl
bpl_poke
	dc.w	bplcon0,%0100000000000000	; 4 BP, Low res
	dc.w	bplcon1
cop_scroll_register
	dc.w	0			; scroll for top part of screen

;	dc.w	intenar,%0111111111111111	; confused?

diwstrt_poke
	dc.w	diwstrt,the_diwstrt		; display start
	dc.w	diwstop,(display_start+208)<<8&$ff00+$c1
	dc.w	ddfstrt,$0030		; usually 38
	dc.w	ddfstop,$00d0
	
cop_top_palette
	dc.w	colour0,$000
	dc.w	colour1,$00f
	dc.w	colour2,$0f0
	dc.w	colour3,$f00
	dc.w	colour4,$0ff
	dc.w	colour5,$ff0
	dc.w	colour6,$f0f
	dc.w	colour7,$fff
	dc.w	colour8,$000
	dc.w	colour9,$000
	dc.w	colour10,$000
	dc.w	colour11,$000
	dc.w	colour12,$000
	dc.w	colour13,$000
	dc.w	colour14,$000
	dc.w	colour15,$0f0


	dc.w	bpl1mod,4+4+(maxw)*2*(noff-1)    	; modulus for scroller 
	dc.w	bpl2mod,4+4+(maxw)*2*(noff-1)    	; modulus for scroller 

cop_bot_bplpth
	dc.w	bpl1pth,0		; high address of bot part of screen
	dc.w	bpl1ptl,0		; low address of bot part of screen
	dc.w	bpl2pth,0
	dc.w	bpl2ptl,0
	dc.w	bpl3pth,0
	dc.w	bpl3ptl,0
	dc.w	bpl4pth,0
	dc.w	bpl4ptl,0
	dc.w	bpl5pth,0
	dc.w	bpl5ptl,0

; This is a one bitplane playfield, formed by reusing the sprite 0
; dma slot, repeatedly writing to it with the copper
; - this is used so we can have sprites overlaying it
; without worrying about scrolling etc

panel_palette
	dc.w	colour16,$000
	dc.w	colour17,$000
	dc.w	colour18,$000			; bg col for spr blp
	dc.w	colour19,$fff	 		; colour for this BPL

	dc.w	colour20,$000
	dc.w	colour21,$000
	dc.w	colour22,$000
	dc.w	colour23,$000

	dc.w	colour24,$000
	dc.w	colour25,$000
	dc.w	colour26,$000
	dc.w	colour27,$000

	dc.w	colour28,$000
	dc.w	colour29,$000
panel_colour	equ	*+2
	dc.w	colour30,$000
	dc.w	colour31,$fff

panel_start	equ	*+18		; addr of first word in bpl
.wait	set	(display_start<<8)+$31 			; first line of sprite playfield
.spr	set	$0000
	rept	16

	dc.w	.wait,$fffe		; wait for a bit
	dc.w	colour31,$4f4		; first half colour
	dc.w	spr6ctl,$6d60
.pos	set	$0040	      		; $40 for screen x start

	rept	9	   		; 20 words per screen
	dc.w	spr6pos,.pos
	dc.w	spr6data,0		; actual bpl data
.pos	set	.pos+8
	endr

	dc.w	copnop,0		; dummy	
	dc.w	copnop,0		; dummy
.pos	set	.pos+8
	dc.w	copnop,0		; dummy
	dc.w	colour31,$4ff		; second half colour
.pos	set	.pos+8

	rept	9	   		; 20 words per screen
	dc.w	spr6pos,.pos
	dc.w	spr6data,0		; the actual bpl data
.pos	set	.pos+8
	endr

.wait	set	.wait+$0100
.spr	set	.spr+1
	endr
	dc.w	spr6data,0
	dc.w	spr6datb,0

panel_loff	equ    20*8+12	



; after first 16 lines then turn fifth bitplane back on
	dc.w	(display_start+16)<<8+$01,$ff00
	dc.w	bplcon0,%0101000000000000	; 5 BP, Low res

cop_bot_5
	dc.w	bpl5pth,0
	dc.w	bpl5ptl,0

; and set colours for main background

cop_bot_palette
	dc.w	colour16,$000
	dc.w	colour17,$00f
	dc.w	colour18,$0f0
	dc.w	colour19,$f00
	dc.w	colour20,$0ff
	dc.w	colour21,$ff0
	dc.w	colour22,$f0f
	dc.w	colour23,$fff
	dc.w	colour24,$000
	dc.w	colour25,$000
	dc.w	colour26,$000
	dc.w	colour27,$000
	dc.w	colour28,$000
	dc.w	colour29,$000
	dc.w	colour30,$000
	dc.w	colour31,$000

	if	(display_start+208)>255
	dc.w	$ffdf,$fffe			; wait for line 256 (PAL)
	dc.w	(display_start+208-256)<<8+01,$ff00	; wait for last line
	elseif
	dc.w	(display_start+208)<<8+01,$ff00		; wait for last line
	endc

	if	use_bad_copper
	dc.w	cop1lch,$0000	    		; restore copper
copper_crash
	dc.w	cop1lcl,main_copper	; corrupt this for instant crash
	endc

	dc.w	intreq,%1000000000010000	; copper interrupt

	dc.w	$ffff,$fffe		; end copper

main_copper_end

	if	~use_bad_copper
copper_crash	dc.w	0,0
	endc

; this sprite defines what the SPR6DATB register contains for sprite BPL
; i.e. the background bitmask for the panel
silly
	dc.w	$1d60,$1e00
silly_data
	dc.w	$ffff,$ffff
	dc.w	0,0,0,0


dummy_sprite	
	dc.l	0,0


	list	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Variables

time		dc.l	0
frame_time	dc.l	0

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	if	final
	rsreset	base+94000	       		; memory for program
	elseif
	rsreset	base+94000	       		; memory for program (was 92)
	endc

	rs.b	1536				; 1.5k for stack
stack	rs.b	0

screens_start  	rs.b	0
		rs.b	1024		; allow a bit of leeway
screen1		rs.b	maxw*(maxh+1)*32*noff	; one screen
		rs.b	50		; allow a bit of leeway
screen2		rs.b	maxw*(maxh+1)*32*noff	; and the other
		rs.b	50		; allow a bit of leeway
screen3		rs.b	maxw*(maxh+1)*32*noff	; and the other other
		rs.b	600		; allow a bit of leeway
screens_end	rs.b	0

;lzw_buffer	equ	screen2
;line_buffer	equ	screen2

woarg		rs.b	0

free_memory	set	woarg
		nolist
