; Amiga Full directionional hardware scroll
; (Really Really Understood Version)
; It works !!! (21-02-91)
;
; todos
;	Faster updates of bleeds - esp splatting more than one chr
;	 at a time, all that working out
;	Move by n pixels & work out which chrs need updating 
;
;	Splitting and restoring sprite routine (buffer or copy)
;
; ------ done a splat n for ud, inergrate this and do for LR

; flicker may be due to wait >256


	ifnd	st
st	equ	0		; 1=ST, 0=amiga (!)
	endc

setup_map
	move.w	#32,map_w
	move.w	#12,map_h
	move.w	#0,map_x
	move.w	#0,real_map_x
	move.w	#0,map_y
	rts	

draw_map
	move.l	screen,a0
;	lea	loff*16(a0),a0
	move.w	#loff*16/4-1,d7
.x	clr.l	(a0)+
	dbf	d7,.x
	bsr	print_map_screen

;	move.l	real,a0
;	lea	loff*16(a0),a0
;	bsr	print_map_screen
;	move.l	background,a0
;	lea	loff*16(a0),a0
;	bsr	print_map_screen
	clr.w	right_build
	clr.w	left_build
	clr.w	top_build
	clr.w	bot_build
	rts

test_scroll

.ug

;	move.w	#$007,colour0+custom

;	bsr	flip_screens

;	bra	.ug
	rts


; scroll real_map_x to equal map_x
scroll_map
;	move.w	#$f00,$dff180
	move.w	real_map_x,d0
	cmp.w	map_x,d0
	bge	.gt

; check if the map WANTS to be scrolled
	move.w	map_x,d1
	add.w	#(maxw-5)*16+1,d1
	cmp.w	max_map_x,d1
	blt 	.ok_r
; check that the map CAN be scrolled
	move.w	max_map_x,d1
	sub.w	#(maxw-5)*16+1,d1
	move.w	d1,map_x


	bra	.ok
.ok_r
	move.w	real_map_x,-(sp)
	bsr	move_right_1
	move.w	(sp)+,d0
	cmp.w	real_map_x,d0
	beq	.ok
	bra	scroll_map
.gt
	move.w	real_map_x,d0
	cmp.w	map_x,d0
	beq	.ok
	move.w	real_map_x,-(sp)
	bsr	move_left_1
	move.w	(sp)+,d0
	cmp.w	real_map_x,d0
	beq.s	.ok
	bra	scroll_map
.ok
;	move.w	#0,$dff180
	rts


solid_scroll_map
	pushem
.loop
	move.w	real_map_x,d0
	cmp.w	map_x,d0
	bge	.gt
.ok_r
	bsr	really_move_right_1
	bra	.loop
.gt
	move.w	real_map_x,d0
	cmp.w	map_x,d0
	beq	.ok
	bsr	really_move_left_1
	bra	.loop
.ok
	popem
no_way_hose
	rts


move_right_1
	move.w	real_map_x,d0
	add.w	#(maxw-5)*16,d0
	cmp.w	max_map_x,d0
	bge 	no_way_hose
really_move_right_1
	bsr	build_right_edge		; do one every time
	move.w	real_map_x,d0
	and.w	#$f,d0
	cmp.w	#$f,d0
	bne	.ok
.build_edge
	cmp.w	#maxh,right_build
	beq.s	.edge_built
	bsr	build_right_edge
	bra.s	.build_edge
.edge_built
	addq.l	#2,screen
	addq.l	#2,real
	addq.l	#2,background
	clr.w	right_build			; right is empty
	move.w	#maxh,left_build		; left is full
.zero_bot
.ok
	add.w	#1,real_map_x
.nope
	rts

move_left_1
	tst.w	real_map_x
	beq	no_way_hose
really_move_left_1
	bsr	build_left_edge			; do one every time
	move.w	real_map_x,d0
	and.w	#$f,d0
	cmp.w	#$0,d0
	bne	.ok
.build_edge
	cmp.w	#maxh,left_build
	beq.s	.edge_built
	bsr	build_left_edge
	bra.s	.build_edge
.edge_built
	subq.l	#2,screen
	subq.l	#2,real
	subq.l	#2,background
	clr.w	left_build			; left is empty
	move.w	#maxh,right_build		; right is full
.ok
	sub.w	#1,real_map_x
.nope
	rts


build_left_edge
;	clr.w	right_build
	move.w	left_build,d7
	cmp.w	#maxh,d7
	bge.s	.nope
	addq.w	#1,left_build
	move.w	#0,d4
	bra.s	building_lr
.nope
	rts

; quick routine to splat one chr, if needed
build_right_edge
;	clr.w	left_build
	move.w	right_build,d7
	cmp.w	#maxh,d7
	bge	.nope
	addq.w	#1,right_build
	move.w	#maxw*2-2,d4		; offset to the_offet (in chrs)
;	move.w	map_x,-(sp)
	bsr.s	building_lr
;	move.w	(sp)+,map_x
.nope
	rts


; given d7 = chr no in the coloum, d4 = column offset
; draw the character in the column
building_lr


; get the base addresses
	move.l	screen,a2		; where to go
	move.l	real,a3
	move.l	background,a4
	lea	loff*16(a2),a2
	lea	loff*16(a3),a3
	lea	loff*16(a4),a4
	move.l	bg_map,a0
	move.l	bg_chr,a1

; work out the dest address of the chr  
	clr.w	d0

	move.w	d7,d5			; get cell number
	lsl.w	#4,d5			; into line number (*16)
	add.w	d5,d0			; add to offset
	bpl	.offset_positive
	add.w	#maxh*16,d0		; now reduce mod maxh*16
	bra	.offset_ok
.offset_positive
	cmp.w	#maxh*16,d0		; ditto
	blt.s	.offset_ok
	sub.w	#maxh*16,d0
.offset_ok
	mulu	#poff*noff,d0	; now convert to offset in screen
	add.l	d0,a2			; and finally to addresses
	add.l	d0,a3
	add.l	d0,a4

; got the dest, now find the source

	move.w	d7,d6

	move.w	map_y,d1
	asr.w	#4,d1
	add.w	d7,d1			; add the chr number 
	add.w	d1,d1
	muls	bg_w,d1

	move.w	real_map_x,d7
	asr.w	#4,d7
	sub.w	#1,d7
	add.w	d7,d7
	add.w	d1,d7	

; finally correct the column offsets
	add.w	d4,d7			; add in to map 


	add.w	d4,a2			; get bleed word addr
	add.w	d4,a3			; get bleed word addr
	add.w	d4,a4			; get bleed word addr

	lea	custom,a6
	bsr	splat_a_chr
	waitblit
	move.w	#%0000100111110000,bltcon0(a6)	;d=a
	move.w	#poff-2,bltamod(a6)
	move.w	#poff-2,bltdmod(a6)
	move.l	a2,bltapth(a6)
	move.l	a3,bltdpth(a6)
	move.w	#(16*5)<<6+1,bltsize(a6)
	waitblit
	move.l	a2,bltapth(a6)
	move.l	a4,bltdpth(a6)
	move.w	#(16*5)<<6+1,bltsize(a6)
	waitblit
	

.nope
	rts


right_build	dc.w	0
left_build	dc.w	0
bot_build	dc.w	0
top_build	dc.w	0

bg_w		dc.w	32

; print a screen full of the start of the maps
print_map_screen
	pushem
	move.l	a0,a2		; where to go
; calculate the map modulo

	move.w	bg_w,d0
	add.w	d0,d0		; length of line
	sub.w	#maxw*2,d0	; minus the displayed bit
	move.w	d0,d6		; d6 = map modulo

	move.w	#-2,d7
	move.w	real_map_x,d0
	asr.w	#4,d0
	add.w	d0,d0
	add.w	d0,d7

	moveq.l	#0,d0
	lea	custom,a6
	moveq	#0,d0
	moveq	#maxh-1,d5	; lines
.line	
	moveq	#maxw-1,d4	; block
.block
	jsr	splat_a_chr
	add.w	#2,d7
	addq.l	#2,a2
	dbf	d4,.block
	add.w	#64-2*maxw,d7
	add.l	#poff*noff*15+poff*(noff-1),a2	; next char line down
	add.w	d6,a0		; add map modulo
	dbf	d5,.line
	popem
	rts

; given d7 = offset in map, a2 = dest on screen
; then print a chr from the bg map, 
;  overlay it with platforms and items as required

splat_a_chr
	pushem
	waitblit
	move.w	#$ffff,bltafwm(a6)
	move.w	#$ffff,bltalwm(a6)
	move.w	#8-2,bltamod(a6)
	move.w	#loff-2,bltcmod(a6)	; screen modulo
	move.w	#loff-2,bltdmod(a6)	; screen modulo
	move.w	#%0000100111110000,bltcon0(a6)	;d=a
	move.w	#16<<6+1,d3
	move.w	#0,bltcon1(a6)

	move.l	bg_chr,a1
	move.l	bg_map,a0
	asr.w	#1,d7
	move.b	(a0,d7.w),d0	; get the block number

	
	and.l	#$ff,d0
	lsl.w	#7,d0		; get block offset
	lea	(a1,d0.l),a4	; a4 is the chite

	move.w	#%0000100111110000,bltcon0(a6)	;d=a
	rept	4
	waitblit
	move.l	a2,bltdpth(a6)		; dest 
	move.l	a4,bltapth(a6)		; source
	move.w	d3,bltsize(a6)		; and splat the bugger
	lea	poff(a2),a2
	addq.l	#2,a4  			; next plane
	endr		
	waitblit
	move.w	#$ffff,bltadat(a6)
;	move.w	#$0000,bltadat(a6)
	move.w	#%0000000111110000,bltcon0(a6)	;d=a
	move.l	a2,bltdpth(A6)	
	move.w	d3,bltsize(a6)		; and splat the bugger
	waitblit

; done the dark background, now overlay the platforms


	move.w	#0,bltamod(a6)
	move.w	#8-2,bltbmod(a6)

	lea	-poff*4(a2),a2
	move.l	the_chr,a1
	move.l	the_map,a0
	move.l	the_masks,a5
	tst.b	bottle_bonus
	bne.s	.bonus
	move.b	(a0,d7.w),d0	; get the block number
	beq	.clear	  	; if zero then dont draw anything	
	bra.s	.normal
; check for bonus chrs here
.bonus
	lea	bottle_map,a4
	tst.b	(a4,d7.w)
	ble.s	.no_bonus
	move.l	bonus_sprite,a4	      
	move.l	bonus_mask,a5
	bra.s	.drawit
.no_bonus
	move.b	(a0,d7.w),d0	; get the block number
	

.normal
	and.w	#$ff,d0
	lsl.w	#5,d0		; get block offset
	lea	(a5,d0.w),a5	; a5 is the mask
	add.w	d0,d0
	add.w	d0,d0
	lea	(a1,d0.w),a4	; a4 is the chite
.drawit
	
	
	waitblit
	move.w	#%0000111111001010,bltcon0(a6)	; cooki cut
	rept	4
	move.l	a2,bltdpth(a6)		; dest 
	move.l	a2,bltcpth(a6)		; dest 
	move.l	a4,bltbpth(a6)		; source
	move.l	a5,bltapth(a6)		; mask source
	move.w	d3,bltsize(a6)		; and splat the bugger
	lea	poff(a2),a2
	addq.l	#2,a4  			; next plane
	waitblit
	endr		
	move.w	#%0000101100001010,bltcon0(a6)	;d=~a*c
	move.l	a2,bltdpth(A6)	
	move.l	a2,bltcpth(a6)		; dest 
	move.l	a5,bltapth(a6)		; mask source
	move.w	d3,bltsize(a6)		; and splat the bugger
	waitblit
	lea	-poff*4(a2),a2


.clear
	add.w	d7,d7			; should be word offset
;	jsr	maybe_item
	popem
	rts



; given a0 = copper address, a1 = screen, make the relevent copper 
qgen_copper
; work out the delay from the map_x
;	add.w	#1,map_x

	addq.l	#2,a1
	move.w	map_x,d1
	and.w	#$f,d1
	neg.w	d1
	add.w	#16,d1
	cmp.w	#16,d1
	blt	.not_16
	clr.w	d1
	subq.l	#2,a1
.not_16

	move.w	d1,correction

	move.w	d1,d0
	lsl.w	#4,d0
	or.w	d1,d0
	move.w	d0,cop_scroll_register

	move.l	a1,d0
	lea	cop_bot_bplpth+2,a2		; top screen addr
	rept	noff
	swap	d0
	move.w	d0,(a2)
	swap	d0
	move.w	d0,4(a2)
	addq.l	#8,a2
	add.l	#poff,d0
	endr

	

	rts


; given a0 = copper address, a1 = screen, make the relevent copper 
qgen_copper_2

; alter the screen to skip top and left bleeds
	lea	2(a1),a1

; work out the delay from the map_x

;	move.l	a1,d0				; screen addr
	move.w	map_x,d1
	and.w	#$f,d1
	neg.w	d1
	add.w	#16,d1
	cmp.w	#16,d1
	blt	.not_16
	clr.w	d1
	subq.l	#2,a1
.not_16

; got delay, so put into both scroll registers
	move.w	d1,d0
	lsl.w	#4,d0
	or.w	d1,d0
	move.w	d0,cop_scroll_register

; may have to alter screen address here if moved over word boundry
	move.w	map_x,d1     		; d1 = x display posn
	move.w	real_map_x,d2		; d2 = x where it was dumped from
	and.w	#$fff0,d1
	and.w	#$fff0,d2
	sub.w	d2,d1
	beq.s	.x_ok
	asr.w	#3,d1
	add.w	d1,a1
.x_ok
; plonk the screen address down	in all 5 planes
	move.l	a1,d0	        

	lea	cop_bot_bplpth+2,a2		; top screen addr
	rept	noff
	swap	d0
	move.w	d0,(a2)
	swap	d0
	move.w	d0,4(a2)
	addq.l	#8,a2
	add.l	#poff,d0
	endr

; and do the second setting up of plane 5
	lea	cop_bot_5+2,a2	    		; frig plane 5 to correct
	add.l	#loff*16-poff,d0
	swap	d0
	move.w	d0,(a2)
	swap	d0
	move.w	d0,4(a2)
	addq.l	#8,a2


	rts

; flip the screens by making a new copper list
; and then pointing to it next vbl
flip_screens
	move.l	screen,a1
	move.l	real,screen
	move.l	a1,real
	pause	#1			; wait for vbl
;	addq.l	#2,screen		; for silly effect
	rts


; ensure screen1 is the real screen
one_screen
	move.l	real,d0
	sub.l	#screen1,d0
	abs.l	d0
	cmp.l	#10000,d0   		; somewhere near this screen ?
	blt	.ok		   	; is so then leave it

;	move.l	real,a0
;	move.l	#screen1,a1
;	move.w	#maxw*maxh*160/4-1,d0
;.copy	move.l	(a0)+,(a1)+
;	dbf	d0,.copy

	jsr	flip_screens
	jsr	flip_lists

.ok
	rts

min_map_x	dc.w	0
max_map_x	dc.w	0

correction	dc.w	0


